package src.hw8Amoeba;

public class BusModelAmoeba implements MathFunction3 {
    private double p  = 3.59;   // Density
    private double jj  = 0.05;   // Walk access speed
    private double k  = 0.4;    // Wait-hdwy ratio
    private double c  = 50;     // Bus cost
    private double v  = 0.167;  // Bus speed
    private double a0 = 0.41;   // Demand coefficients
    private double a2 = 0.0081;
    private double a4 = 0.0014;
	private double T= 60;   	// Time period of analysis (min)
	private double X= 4;		// Width of analysis area (mi)
	private double Y= 6; 		// Length of analysis area (mi)
    
    // Methods to return initial guesses for optimal values
    public double getRteSpacing() {
        return Math.pow((64*jj*jj*k*a4*c/(p*v*a0*a2)), 1.0/3.0);
    }
    
    public double getHeadway() {
        return Math.pow((a4*c/(p*a0*a2*k*k*jj*v)), 1.0/3.0);
    }
    
    public double getFare() {
        return (0.5*a0/a4 - Math.pow((k*c*a2*a2)/(jj*a4*a4*p*v*a0), 1.0/3.0));
    }

	public double func2(double[] x) {
		double g= x[0];
		double f= x[1];
		double h= 0.25*g/(jj*k);
		double cost= 2*X*T*c*Y/(g*h*v);
		double revenue= T*p*X*Y*f*(a0-a2*(k*h+0.25*g/jj)-a4*f);
		return -(revenue - cost);		// We're using a minimization amoeba to find a maximum
	}
}